/** Maintain info about a worker */
public class W {
	/** worker's last name (not null) */
	private String lastName;

	/** worker's social security number */
	private int ssn;

	/** worker's boss (null if none) */
	private W boss;

	/** Constructor: worker with last name n, SSN s, boss b (null if none). <br>
	 * Precondition: n not null, s in 0..999999999. */
	public W(String n, int s, W b) {
		lastName= n;
		ssn= s;
		boss= b;
	}

	/** = worker's last name */
	public String getLname() {
		return lastName;
	}

	/** = last 4 SSN digits */
	public String getSsn() {
		return "" + ssn % 10000;
	}

	/** = worker's boss (null if none) */
	public W getBoss() {
		return boss;
	}

	/** Set boss to b. */
	public void setBoss(W b) {
		boss= b;
	}

	@Override
	public String toString() {
		return "Worker " + lastName +
			" has SSN ???-??-" + getSsn() +
			(boss == null ? "" : " and boss " + boss.lastName);
	}

	/** "x is y's boss" <br>
	 * Pre: x and y are not null */
	public static boolean isBoss(W x, W y) {
		return x == y.boss;
	}

	/** "this is other's boss" <br>
	 * Pre: other is not null */
	public boolean isBossOf(W other) {
		return this == other.boss;
	}

	public static void main(String[] args) {
		W martha= new W("Pollack", 123456789, null);
		System.out.println(martha);
	}
}